import java.util.*;

public class HashIndex{

    private int     hashCounter;   
    private HashMap hashTable;     

    public HashIndex(){
	hashCounter = 0;
	hashTable = new HashMap();
    }

    public HashIndex(int init){
	hashCounter = init;
	hashTable = new HashMap();
    }

    public void incCount(){
	hashCounter++;
    }

    public int getCount(){
	return hashCounter;
    }

    public int get(String str){
	if (hashTable.containsKey(str) == false){
	    hashTable.put(str, new Integer(hashCounter));
	    hashCounter++;
	}
	else
	    ;

	return ((Integer)hashTable.get(str)).intValue();
    }

    public static void main(String[] args){
	HashIndex hash = new HashIndex(5);

	add("this", hash);
	add("is", hash);
	add("a", hash);
	add("pen", hash);
	add("that", hash);
	add("is", hash);
	add("my", hash);
	add("pen", hash);

	System.out.println();
	System.out.println(hash.hashTable.toString());
    }

    public static void add(String str, HashIndex hash){
	System.out.println("string: " + str + " id: " + hash.get(str));
    }
}


class HashMultiIndex{

    private HashIndex hashTable;        
    private HashMap   hashTableMulti;   

    public HashMultiIndex(){
	hashTable = new HashIndex();
	hashTableMulti = new HashMap();
    }

    public HashMultiIndex(int init){
	hashTable = new HashIndex(init);
	hashTableMulti = new HashMap();
    }

    public int[] get(String key, String[] values){
	if (hashTableMulti.containsKey(key) == false){
	    int[] ids = new int[values.length + 1];
	    ids[0] = hashTable.getCount();
	    hashTable.incCount();
	    for (int i = 0; i < values.length; i++)
		ids[i + 1] = hashTable.get(values[i]);
	    hashTableMulti.put(key, ids);
	}
	else
	    ;
	
	return (int[])hashTableMulti.get(key);
    }

    public int[] get(String[] strs){
	if (hashTableMulti.containsKey(strs[0]) == false){
	    int[] ids = new int[strs.length];
	    for (int i = 0; i < strs.length; i++)
		ids[i] = hashTable.get(strs[i]);
	    hashTableMulti.put(strs[0], ids);
	}
	else
	    ;
	
	return (int[])hashTableMulti.get(strs[0]);
    }

    public static void main(String[] args){
	HashMultiIndex hash = new HashMultiIndex(5);

	add("html", new String[]{"grammer", "tag"}, hash);
	add("meta", new String[]{"info", "tag"}, hash);
	add("a", new String[]{"hyperlink", "tag"}, hash);
	add("br", new String[]{"base", "tag"}, hash);
	add("font", new String[]{"shape", "tag"}, hash);
	add("table", new String[]{"shape", "tag"}, hash);
	add("href", new String[]{"attribute"}, hash);
	add("http://www.yahoo.co.jp/", new String[]{}, hash);
	add("u", new String[]{"shape"}, hash);
	add("br", new String[]{"base", "tag"}, hash);
	add("br", new String[]{"string"}, hash);
    }

    public static void add(String real, String[] upper, HashMultiIndex hash){
	System.out.print("string: " + real + " concept:");
	for (int i = 0; i < upper.length; i++)
	    System.out.print(" " + upper[i]);
	System.out.print(" id:");
	int[] ids = hash.get(real, upper);
	for (int i = 0; i < ids.length; i++)
	    System.out.print(" " + ids[i]);
	System.out.println();
    }

    public static void add(String[] strs, HashMultiIndex hash){
	System.out.print("string:");
	for (int i = 0; i < strs.length; i++)
	    System.out.print(" " + strs[i]);
	System.out.print(" id:");
	int[] ids = hash.get(strs);
	for (int i = 0; i < ids.length; i++)
	    System.out.print(" " + ids[i]);
	System.out.println();
    }
}





